import type { BaseContract, BigNumber, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../common";
export interface IIMXFarmUInterface extends utils.Interface {
    functions: {
        "accrueInterest()": FunctionFragment;
        "collateralToken()": FunctionFragment;
        "farmRouter()": FunctionFragment;
        "getUnderlyingShortReserves()": FunctionFragment;
        "impermaxChef()": FunctionFragment;
        "pair()": FunctionFragment;
        "pendingHarvest()": FunctionFragment;
        "sBorrowable()": FunctionFragment;
        "short()": FunctionFragment;
        "uBorrowable()": FunctionFragment;
        "underlying()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "accrueInterest" | "collateralToken" | "farmRouter" | "getUnderlyingShortReserves" | "impermaxChef" | "pair" | "pendingHarvest" | "sBorrowable" | "short" | "uBorrowable" | "underlying"): FunctionFragment;
    encodeFunctionData(functionFragment: "accrueInterest", values?: undefined): string;
    encodeFunctionData(functionFragment: "collateralToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "farmRouter", values?: undefined): string;
    encodeFunctionData(functionFragment: "getUnderlyingShortReserves", values?: undefined): string;
    encodeFunctionData(functionFragment: "impermaxChef", values?: undefined): string;
    encodeFunctionData(functionFragment: "pair", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingHarvest", values?: undefined): string;
    encodeFunctionData(functionFragment: "sBorrowable", values?: undefined): string;
    encodeFunctionData(functionFragment: "short", values?: undefined): string;
    encodeFunctionData(functionFragment: "uBorrowable", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    decodeFunctionResult(functionFragment: "accrueInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "farmRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUnderlyingShortReserves", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "impermaxChef", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pair", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingHarvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sBorrowable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "short", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "uBorrowable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    events: {
        "HarvestedToken(address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "HarvestedToken"): EventFragment;
}
export interface HarvestedTokenEventObject {
    token: string;
    amount: BigNumber;
}
export type HarvestedTokenEvent = TypedEvent<[
    string,
    BigNumber
], HarvestedTokenEventObject>;
export type HarvestedTokenEventFilter = TypedEventFilter<HarvestedTokenEvent>;
export interface IIMXFarmU extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IIMXFarmUInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        accrueInterest(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        collateralToken(overrides?: CallOverrides): Promise<[string]>;
        farmRouter(overrides?: CallOverrides): Promise<[string]>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        impermaxChef(overrides?: CallOverrides): Promise<[string]>;
        pair(overrides?: CallOverrides): Promise<[string]>;
        pendingHarvest(overrides?: CallOverrides): Promise<[BigNumber] & {
            harvested: BigNumber;
        }>;
        sBorrowable(overrides?: CallOverrides): Promise<[string]>;
        short(overrides?: CallOverrides): Promise<[string]>;
        uBorrowable(overrides?: CallOverrides): Promise<[string]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
    };
    accrueInterest(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    collateralToken(overrides?: CallOverrides): Promise<string>;
    farmRouter(overrides?: CallOverrides): Promise<string>;
    getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
    }>;
    impermaxChef(overrides?: CallOverrides): Promise<string>;
    pair(overrides?: CallOverrides): Promise<string>;
    pendingHarvest(overrides?: CallOverrides): Promise<BigNumber>;
    sBorrowable(overrides?: CallOverrides): Promise<string>;
    short(overrides?: CallOverrides): Promise<string>;
    uBorrowable(overrides?: CallOverrides): Promise<string>;
    underlying(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        accrueInterest(overrides?: CallOverrides): Promise<void>;
        collateralToken(overrides?: CallOverrides): Promise<string>;
        farmRouter(overrides?: CallOverrides): Promise<string>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        impermaxChef(overrides?: CallOverrides): Promise<string>;
        pair(overrides?: CallOverrides): Promise<string>;
        pendingHarvest(overrides?: CallOverrides): Promise<BigNumber>;
        sBorrowable(overrides?: CallOverrides): Promise<string>;
        short(overrides?: CallOverrides): Promise<string>;
        uBorrowable(overrides?: CallOverrides): Promise<string>;
        underlying(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "HarvestedToken(address,uint256)"(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
        HarvestedToken(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
    };
    estimateGas: {
        accrueInterest(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        collateralToken(overrides?: CallOverrides): Promise<BigNumber>;
        farmRouter(overrides?: CallOverrides): Promise<BigNumber>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<BigNumber>;
        impermaxChef(overrides?: CallOverrides): Promise<BigNumber>;
        pair(overrides?: CallOverrides): Promise<BigNumber>;
        pendingHarvest(overrides?: CallOverrides): Promise<BigNumber>;
        sBorrowable(overrides?: CallOverrides): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<BigNumber>;
        uBorrowable(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        accrueInterest(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        collateralToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        farmRouter(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        impermaxChef(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pair(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingHarvest(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        sBorrowable(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        short(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        uBorrowable(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
